{$I compiler }
UNIT BabelEvt;INTERFACE USES Objects,Views,Dialogs,
                             Babel_X,Babel_I;
   {|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

   BABEL - Provide dialog in appropriate language

   |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||}
function PrintDialog : PDialog ;
function CreateFindDialog : PDialog ;
function CreateReplaceDialog : PDialog ;
IMPLEMENTATION
   {===================================================================

   SELECT PRINTER

   ===================================================================}
function PrintDialog : PDialog ;
   {-------------------------------------------------------------------
   ENGLISH
   -------------------------------------------------------------------}
function PrintE : PDialog ;
{$IFDEF code}{$I port.src }{$ENDIF}
begin
{$IFDEF code}
   PrintE                    := MakeDialog ;
{$ELSE}
   PrintE                    := PDialog ( RezFile^.Get ( 'DIALOG_PORT' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   GERMAN
   -------------------------------------------------------------------}
function PrintG : PDialog ;
{$IFDEF code}{$I portG.src }{$ENDIF}
begin
{$IFDEF code}
   PrintG                    := MakeDialog ;
{$ELSE}
   PrintG                    := PDialog ( RezFile^.Get ( 'DIALOG_PORTG' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   SPANISH
   -------------------------------------------------------------------}
function PrintS : PDialog ;
{$IFDEF code}{$I portS.src }{$ENDIF}
begin
{$IFDEF code}
   PrintS                    := MakeDialog ;
{$ELSE}
   PrintS                    := PDialog ( RezFile^.Get ( 'DIALOG_PORTS' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   FRENCH
   -------------------------------------------------------------------}
function PrintF : PDialog ;
{$IFDEF code}{$I portF.src }{$ENDIF}
begin
{$IFDEF code}
   PrintF                    := MakeDialog ;
{$ELSE}
   PrintF                    := PDialog ( RezFile^.Get ( 'DIALOG_PORTF' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   DUTCH 
   -------------------------------------------------------------------}
function PrintD : PDialog ;
{$IFDEF code}{$I portD.src }{$ENDIF}
begin
{$IFDEF code}
   PrintD                    := MakeDialog ;
{$ELSE}
   PrintD                    := PDialog ( RezFile^.Get ( 'DIALOG_PORTD' ) ) ;
{$ENDIF}
end ;
   {- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
begin
   case DefaultHint [ 1 ] of
   'G' : PrintDialog    := PrintG ;
   'S' : PrintDialog    := PrintS ;
   'F' : PrintDialog    := PrintF ;
   'D' : PrintDialog    := PrintD ;
   else
      PrintDialog            := PrintE ;
   end ;
end ;
   {===================================================================

   SEARCH - created with DLGDSN

   ===================================================================}
function CreateFindDialog : PDialog ;
   {-------------------------------------------------------------------
   ENGLISH
   -------------------------------------------------------------------}
function EFind : PDialog ;
{$IFDEF code} {$I find.src } {$ENDIF}
begin
{$IFDEF code}
   EFind                     := MakeDialog ;
{$ELSE}
   EFind                     := PDialog ( RezFile^.Get ( 'DIALOG_FIND' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   GERMAN
   -------------------------------------------------------------------}
function FindG : PDialog ;
{$IFDEF code} {$I FindG.src } {$ENDIF}
begin
{$IFDEF code}
   FindG                     := MakeDialog ;
{$ELSE}
   FindG                     := PDialog ( RezFile^.Get ( 'DIALOG_FINDG' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   SPANISH
   -------------------------------------------------------------------}
function FindS : PDialog ;
{$IFDEF code} {$I FindS.src } {$ENDIF}
begin
{$IFDEF code}
   FindS                     := MakeDialog ;
{$ELSE}
   FindS                     := PDialog ( RezFile^.Get ( 'DIALOG_FINDS' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   FRENCH
   -------------------------------------------------------------------}
function FindF : PDialog ;
{$IFDEF code} {$I FindF.src } {$ENDIF}
begin
{$IFDEF code}
   FindF                     := MakeDialog ;
{$ELSE}
   FindF                     := PDialog ( RezFile^.Get ( 'DIALOG_FINDF' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   DUTCH
   -------------------------------------------------------------------}
function FindD : PDialog ;
{$IFDEF code} {$I FindD.src } {$ENDIF}
begin
{$IFDEF code}
   FindD                     := MakeDialog ;
{$ELSE}
   FindD                     := PDialog ( RezFile^.Get ( 'DIALOG_FINDD' ) ) ;
{$ENDIF}
end ;
   {- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
begin
   case DefaultHint [ 1 ] of
   'G' : CreateFindDialog    := FindG ;
   'S' : CreateFindDialog    := FindS ;
   'F' : CreateFindDialog    := FindF ;
   'D' : CreateFindDialog    := FindD ;
   else
      CreateFindDialog       := EFind ;
   end ;
end ;
   {===================================================================

   REPLACE - created with DLGDSN

   ===================================================================}
function CreateReplaceDialog : PDialog ;
   {-------------------------------------------------------------------
   ENGLISH
   -------------------------------------------------------------------}
function ReplaceE : PDialog ;
{$IFDEF code} {$I replace.src } {$ENDIF}
begin
{$IFDEF code}
   ReplaceE                  := MakeDialog ;
{$ELSE}
   ReplaceE                  := PDialog ( RezFile^.Get ( 'DIALOG_REPLACE' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   GERMAN
   -------------------------------------------------------------------}
function ReplaceG : PDialog ;
{$IFDEF code} {$I replaceG.src } {$ENDIF}
begin
{$IFDEF code}
   ReplaceG                  := MakeDialog ;
{$ELSE}
   ReplaceG                  := PDialog ( RezFile^.Get ( 'DIALOG_REPLACEG' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   SPANISH
   -------------------------------------------------------------------}
function ReplaceS : PDialog ;
{$IFDEF code} {$I replaceS.src } {$ENDIF}
begin
{$IFDEF code}
   ReplaceS                  := MakeDialog ;
{$ELSE}
   ReplaceS                  := PDialog ( RezFile^.Get ( 'DIALOG_REPLACES' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   FRENCH
   -------------------------------------------------------------------}
function ReplaceF : PDialog ;
{$IFDEF code} {$I replaceF.src } {$ENDIF}
begin
{$IFDEF code}
   ReplaceF                  := MakeDialog ;
{$ELSE}
   ReplaceF                  := PDialog ( RezFile^.Get ( 'DIALOG_REPLACEF' ) ) ;
{$ENDIF}
end ;
   {-------------------------------------------------------------------
   DUTCH 
   -------------------------------------------------------------------}
function ReplaceD : PDialog ;
{$IFDEF code} {$I replaceD.src } {$ENDIF}
begin
{$IFDEF code}
   ReplaceD                  := MakeDialog ;
{$ELSE}
   ReplaceD                  := PDialog ( RezFile^.Get ( 'DIALOG_REPLACED' ) ) ;
{$ENDIF}
end ;
   {- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -}
begin
   case DefaultHint [ 1 ] of
   'G' : CreateReplaceDialog    := ReplaceG ;
   'S' : CreateReplaceDialog    := ReplaceS ;
   'F' : CreateReplaceDialog    := ReplaceF ;
   'D' : CreateReplaceDialog    := ReplaceD ;
   else
      CreateReplaceDialog       := ReplaceE ;
   end ;
end ;
   {^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^}
END.
