{

    TASK.PAS - Unit Interface to TASK.C

}

unit TASK;

interface

uses CINTRIN;

var
    _current_task : Integer;

procedure switch_task;
procedure start_task(id : Integer; stack : Pointer; task : Pointer);
procedure enable_task(id : Integer);
procedure disable_task(id : Integer);
procedure delay_task(milliseconds : Integer);

implementation

{$L TASK}
{$F+}
procedure switch_task; external;
procedure start_task(id : Integer; stack : Pointer; task : Pointer); external;
procedure enable_task(id : Integer); external;
procedure disable_task(id : Integer); external;
procedure delay_task(milliseconds : Integer); external;
procedure initialize_task; external;
{$F-}

{$L SETJMP} { from CC.LIB }
procedure _setjmp; external;
procedure _longjmp; external;

procedure _abort;
    begin
    WriteLn('Task tried to exit');
    Halt(1)
    end;

begin
initialize_task;
end.
