{

    CINTRIN - C intrinsics

    These routines are NOT to be called from PASCAL directly, but serve
    to declare the C Intrinsic Library functions for the use of C
    routines.

}

unit CINTRIN;

interface

procedure LDIV_;
procedure LMOD_;
procedure LUDIV_;
procedure LUMOD_;
procedure LLSH_;
procedure LRSH_;
procedure LURSH_;
procedure LXMUL_;
procedure OVERFLOW_;
procedure PADA_;
procedure PSBA_;
procedure PADD_;
procedure PSUB_;
procedure PCMP_;
procedure PDEA_;
procedure PINA_;
procedure PSBP_;
procedure SCOPY_;
procedure SPUSH_;

implementation

{$L LDIV}
procedure LDIV_; external;
procedure LMOD_; external;
procedure LUDIV_; external;
procedure LUMOD_; external;

{$L LRSH}
procedure LLSH_; external;
procedure LRSH_; external;
procedure LURSH_; external;

{$L LXMUL}
procedure LXMUL_; external;

{$L OVERFLOW}
procedure OVERFLOW_; external;

{$L PADA}
procedure PADA_; external;
procedure PSBA_; external;

{$L PADD}
procedure PADD_; external;
procedure PSUB_; external;

{$L PCMP}
procedure PCMP_; external;

{$L PINA}
procedure PDEA_; external;
procedure PINA_; external;

{$L PSBP}
procedure PSBP_; external;

{$L SCOPY}
procedure SCOPY_; external;

{$L SPUSH}
procedure SPUSH_; external;

end.
