{$M 16384,0,655360}

(* This is a test program for the TSUNT45.TPU unit *)

uses Dos
     {$IFDEF VER40}
     ,TSUNT45
     {$ENDIF}
     ;

procedure LOGO;
begin
  writeln;
  writeln ('TSUNT45 unit test by Prof. Timo Salmi');
  writeln ('University of Vaasa, Finland, ts@chyde.uwasa.fi');
  writeln;
end;

(* Which Dos version *)
procedure TEST1;
begin
  writeln ('Dos version ', Lo(DosVersion), '.', Hi(DosVersion));
end;  (* test1 *)

(* Number of environment strings *)
procedure TEST2;
begin
  write ('The number of environment strings is ');
  writeln (EnvCount);
end;  (* test2 *)

(* Display environment strings *)
procedure TEST3;
var i : integer;
begin
  for i := 1 to EnvCount do writeln (EnvStr(i));
end;  (* test3 *)

(* Display a particular environment string *)
procedure TEST4;
var i : integer;
begin
  writeln ('Path is ', GetEnv('path'));
  Flush (output);
end;  (* test4 *)

(* The name of the current program *)
procedure TEST5;
begin
  writeln (ParamStr0);
end;  (* test5 *)

(* The expanded name of any program *)
procedure TEST6;
begin
  writeln (FExpand('anyprog'));
end;  (* test6 *)

(* Main program: the tests *)
begin
  LOGO;
  TEST1;
  TEST2;
  TEST3;
  TEST4;
  TEST5;
  TEST6;
end.  (* tsunt45.tst *)